/*
 * @Author: jixiang
 * @Date: 2021-09-10 16:42:20
 * @Description:
 * @FilePath: /suqian_account_new/src/api/bookManage.ts
 * One World One Drefeel(56580223@qq.com)
 */
import { HttpResponse } from '@/@type';
import Axios from './axios';

const bookpackge = {
  getBookStatusDropDown: '/fighter-library/book/getBookStatusDropDown',
  listTopCategory: '/fighter-library/CateRelation/listTopCategory',
  queryPackage: '/fighter-library/book/queryBookByPage',
  deleteBatchBook: '/fighter-library/book/deleteBatchBook',
  batchUpperOrLower: '/fighter-library/book/batchUpperOrLower',
  releaseBook: '/fighter-library/book/releaseBook',
  backBook: '/fighter-library/book/backBook',
  listCategory: '/fighter-library/CateRelation/listChildCategory',
  listTree: '/fighter-library/CateRelation/listTree',
};

//  分页查询套餐参数
interface queryParams {
  name: String;
  author: String;
  status: Number;
  createBeginTime: string;
  createEndTime: string;
}

interface querInfo {
  pageNum: Number;
  pageSize: Number;
}

interface batchParams {
  bookIdList: Array<Number>;
  flag: Boolean;
}

interface singleOptionParams {
  id: Number;
}

class packagebook {
  // 图书状态下拉选
  static async getBookStatusDropDown(): Promise<HttpResponse> {
    return Axios(bookpackge.getBookStatusDropDown, {
      method: 'post',
    });
  }
  static async listTree(): Promise<HttpResponse> {
    return Axios(bookpackge.listTree, {
      method: 'post',
    });
  }
  // 图书类型下拉选
  static async listTopCategory(): Promise<HttpResponse> {
    return Axios(bookpackge.listTopCategory, {
      method: 'post',
    });
  }

  // 图书二级类型下拉选
  static async listCategory(params): Promise<HttpResponse> {
    return Axios(bookpackge.listCategory, {
      method: 'post',
      params: params,
    });
  }

  // 分页查询套餐
  static async queryPackage(data: queryParams, params: querInfo): Promise<HttpResponse> {
    return Axios(bookpackge.queryPackage, {
      method: 'post',
      data: data,
      params: params,
    });
  }

  // 批量删除图书
  static async deleteBatchBook(data: batchParams): Promise<HttpResponse> {
    return Axios(bookpackge.deleteBatchBook, {
      method: 'post',
      data: data,
    });
  }

  // 批量上下架
  static async batchUpperOrLower(data: batchParams): Promise<HttpResponse> {
    return Axios(bookpackge.batchUpperOrLower, {
      method: 'post',
      data: data,
    });
  }

  // 发布图书
  static async releaseBook(params: singleOptionParams): Promise<HttpResponse> {
    return Axios(bookpackge.releaseBook, {
      method: 'get',
      params: params,
    });
  }

  // 撤回图书
  static async backBook(params: singleOptionParams): Promise<HttpResponse> {
    return Axios(bookpackge.backBook, {
      method: 'get',
      params: params,
    });
  }
}

export default packagebook;
