/*
 * @Author: jixiang
 * @Date: 2021-07-07 15:19:05
 * @Description: main
 * @FilePath: /suqian_account_new/src/main.ts
 * One World One Drefeel(56580223@qq.com)
 */
import { createApp } from 'vue';
import App from './App.vue';
import router from './router';
import store from './store';
import { AppConfig } from './config/app';
// import Antd from 'ant-design-vue'
import { loadAllPlugins } from './plugins';
import registeGlobalComponent from './components/index';
/**引入公共样式 */
import './styles/index.less';
import './styles/antd.less';
import 'nprogress/nprogress.css';
// App.config.productionTip = false;
/**全局控制 */
import './permission';
/** 将全局静态配置注入到应用中,可以通过 this.a读取,比 provide 和 inject 手动注入更方便  */
const app: ReturnType<typeof createApp> = createApp(App);
app.config.globalProperties = AppConfig;
// app.use(Antd);
/** 加载所有 Plugins */
loadAllPlugins(app);

/** 自动注册全局组件  */
registeGlobalComponent(app);

/**
 * rem自动换算
 * （设计稿字体大小/10）rem
 * */
(function (doc: any, win: any) {
  var doc = doc.documentElement;
  doc.addEventListener('DOMContentLoaded', Resize, false);
  // 当DOM加载后执行
  win.addEventListener('resize', Resize, false);
  if (doc.clientWidth) {
    Resize();
  } else {
    setTimeout(Resize, 100);
  }
  // 当屏幕发生变化时执行
  function Resize() {
    console.log(doc.clientWidth, doc.clientWidth / 192);
    doc.style.fontSize = doc.clientWidth / 192 + 'px';
  }
})(document, window);

app.use(router).use(store).mount('#app');
